

import DocParser from '../util/docparser.js';
import { SimpleSidemenu, SimpleSidemenuGroup, SimpleSidemenuItem } from '../../lib/index.js';
import {ExampledView} from './example.js';
SimpleTabsContainer.register();
SimpleTab.register();


import rawcode from '!raw-loader!../../lib/components/tabs.js';

let __docs = undefined;

const methodNames = {
  'SimpleSidemenu': [],
  'SimpleSidemenuGroup': [],
  'SimpleSidemenuItem': []
};

const eventNames = {
};

class SidemenusView extends ExampledView {

  static title() {
    return "Tabs";
  }

  static propertyElements() {
    return [ 'sc-sidemenu', 'sc-sidemenu-group', 'sc-sidemenu-item' ];
  }
  static propertyTables() {
    return [ 'sidemenu-properties', 'sidemenu-group-properties', 'sidemenu-item-properties' ]
  }

  static methodNames( className ) {
    return methodNames[ className ];
  }

  static eventNames( className ) {
    return eventNames[ className ];
  }

  static getDocs() {
    if ( __docs == undefined )
      __docs = DocParser.parseJs( rawcode );
    return __docs
  }




  static build() {
    return this.builder`
      <div id="sidemenus-page">
        <h2>Sidemenus</h2>
        <div>
          <h3 class="lined">Description</h3>
          <p>The <code>&lt;sc-sidemenu&gt;</code>, <code>&lt;sc-sidemenu-group&gt;</code> and <code>&lt;sc-sidemenu-item&gt;</code> components are a user interactable controls for side-menus. It's intended to be used for side-sitting navigation menus.</p>
        </div>

        <div class="properties">
          <h3 class="lined">Properties</h3>
          <h4><code>&lt;sc-sidemenu&gt;</code></h4>
          <sc-table
              id="sidemenu-properties"
              scrollable
              .fieldDefinitions=${this.propFields}
          >
          </sc-table>

          <h4><code>&lt;sc-sidemenu-group&gt;</code></h4>
          <sc-table
              id=sidemenu-group-properties"
              scrollable
              .fieldDefinitions=${this.propFields}
          >
          </sc-table>

          <h4><code>&lt;sc-sidemenu-item&gt;</code></h4>
          <sc-table
              id="sidemenu-item-properties"
              scrollable
              .fieldDefinitions=${this.propFields}
          >
          </sc-table>

        </div>


        <div class="events">
          <h3 class="lined">Events</h3>
          <h4><code>&lt;sc-sidemenu&gt;</code></h4>
          ${this.buildEvents( 'SimpleSidemenu' )}

          <h4><code>&lt;sc-sidemenu-group&gt;</code></h4>
          ${this.buildEvents( 'SimpleSidemenuGroup' )}
        </div>


        <div class="methods">
          <h3 class="lined">Methods</h3>

          <h4><code>&lt;sc-sidemenu&gt;</code></h4>
          ${this.buildMethods( 'SimpleSidemenu' )}

          <h4><code>&lt;sc-sidemenu-group&gt;</code></h4>
          ${this.buildMethods( 'SimpleSidemenuGroup' )}

          <h4><code>&lt;sc-sidemenu-item&gt;</code></h4>
          ${this.buildMethods( 'SimpleSidemenuItem' )}
        </div>


        <div id="examples" class="examples">
          <h3 class="lined">Examples</h3>



        </div>
      </div>
    `
  }

}


export { TabsView };

