

import fs from 'fs';


console.log( "Read file..." )
const rawdata = fs.readFileSync( 'generated.json' );

console.log( "Parsing..." );
const json = JSON.parse( rawdata );

let rows = [];


console.log( "Indexing" );
const index = new Array( json.length );
json.forEach( ( row, idx ) => {
  if ( ! index[ row.company ] )
    index[ row.company ] = new Array();
  index[ row.company ].push( idx );
} );

console.log( "Index has " + Object.keys( index ).length + " values" );

console.log( "Finding rows..." );
for ( let a = 0; a < 2000000; a++ ) {

  rows = [];

  for ( let idx of index[ "EWAVES" ] )
    rows.push( json[ idx ] );
  
  if ( a == 0 )
    console.log( "Have " + rows.length + " EWAVES people" );
}
console.log( "Completed" );
